/**
 * @file  plc_cfg.h
 * @brief plc_cfg.cͷļ
 * @author fengzhou  
 */

#ifndef _PLC_CFG_H_
#define _PLC_CFG_H_

#include <rtthread.h>
#include "plc_type_define.h"
#include "plc_port.h"

typedef enum Task_Status_Enum{
	TASK_UNAVAILABLE = 0,
	TASK_READY = 1,
	TASK_RUNNING = 2,
	TASK_ERROR = 3
}TASK_STA_E;

/* ʱͳƽṹ */
typedef struct Task_Time_Statistics_Struct{
	USINT       priority;    /*  */
	UDINT       trigTime;    /* 񴥷ʱ */
	UDINT       beginTime;   /* ʼִеʱ */
	UDINT       endTime;     /* ִнʱ */
	UDINT       runTime;     /* еʱ */
	struct Task_Time_Statistics_Struct* pNext;
}TASK_TIME_STAT_S;

/*PLCƿṹ*/
typedef struct Task_Ctrl_Block_Struct{
    UINT        id;
	USINT       priority;              /**< ȼ0ߣ255*/
    BOOL (*singleGet)(void);       /**< singleֵ*/
    TIME (*intervalGet)(void);     /**< intervalֵ*/
	void (*taskRun)(void);
    /*ʱ*/
	TASK_STA_E  taskSta;
	struct rt_semaphore	semTask;
	BOOL        singlePrevious;    /**< ǰһsingleֵжsingle*/
	TIME        intervalBegin;     /**< intervalʼʱ*/

	/* ͳ */
	UDINT       trigCnt;		   /**<  */
	UDINT       runCnt;            /**< д */

	/*ʱͳƣ΢(usec)Ϊλ*/
	UDINT       trigTime;          /**<  񴥷ʱ */
	UDINT       beginTime;         /**<  пʼʱ */
	UDINT       endTime;           /**<  нʱ */
	
	UDINT       runTime;           /**<  ʱ = endTime - beginTime */
	UDINT       runTimeMin;
	UDINT       runTimeMax;
	UDINT       runTimeAverage;
	UINT64      runTimeSum;
	
	UDINT       gapTime;           /**<  ʱ =     current beginTime - previous beginTime */
	UDINT       gapTimeMin;
	UDINT       gapTimeMax;       
	UDINT       gapTimeAverage;
	UINT64      gapTimeSum;
	
	UDINT       delayTime;         /**<  Ӵʼеӳʱ = beginTime - trigTime */
	UDINT       delayTimeMin;
	UDINT       delayTimeMax;
	UDINT       delayTimeAverage;
	UINT64      delayTimeSum;	
	/* ջռʹõٷֱͳ */
	USINT       stkUsedMax;
}TASK_CB_S;

#define MAX_SIZE_OF_RSC_MSG_QUEUE      16  /*Դ¼ϢĿ*/

/*PLCԴ¼*/
#define PLC_RSC_EVT_NULL               0
#define PLC_RSC_EVT_ORDER_TO_RUN       1  /*Դ*/
#define PLC_RSC_EVT_ORDER_TO_STOP      2  /*Դֹͣ*/
#define PLC_RSC_EVT_TASK_READY         3  /*׼*/
#define PLC_RSC_EVT_TASK_TRIGGED       4  /*񴥷*/
#define PLC_RSC_EVT_TASK_RETURN        5  /*ִн*/
#define PLC_RSC_EVT_TASK_ERROR         6  /*ִг*/

typedef struct{
	BYTE       evt;                          /*¼*/
	BYTE       reserved[3];                  /*ֽڶ*/
    TASK_CB_S* ptaskcb;                      /*  */
}RSC_MSG_S;
#define RSC_MSG_SIZE                   sizeof(RSC_MSG_S)

typedef enum Resource_Status_Enum{
	RSC_INITIALIZING = 0,	/**< ڳʼ״̬ */
	RSC_READY_TO_RUN,		/**< ׼״̬ */
	RSC_STOP,				/**< ͣ״̬ */
	RSC_RUNNING,			/**< ״̬ */
	RSC_GOTO_STOP,    		/**< ֹͣ״̬ */
	RSC_ERROR				/**< ״̬ */
}RSC_STA_E;

/*Դƿ*/
typedef struct Resource_Ctrl_Block_Struct{
    UDINT       taskNum;                /**< ûĿĬ */
	TASK_CB_S   taskCB[MAX_TASK_NUM_PER_RSC]; /**< ûƿбĬ */
    TASK_CB_S   taskDefaultCB;          /**< Ĭƿ */
    /*ʱ*/
	RSC_STA_E   rscState;			/**< Դ״̬ */
	UDINT       cycleCnt;         /**< ɨѭӵοʼм */
	UDINT       taskRunningCnt;   /**< еĿĬ */
	
	/*ʱصı΢(usec)Ϊλ*/
	UDINT       runTime;           /**< ʱ */
	UDINT       stopTime;          /**< ͣʱ */
	UDINT       updateTime;        /**< ϴ״̬ʱ */
	/* ѭʱ */
	UDINT       cycleBegin;        /**< ѭʼʱ */
	UDINT       cycleEnd;          /**< ѭʱ */
	
	UDINT       cycleTime;         /**< ѭʱ = endTime - beginTime */
	UDINT       cycleTimeMin;      /**< ѭʱ */
	UDINT       cycleTimeMax;      /**< ѭʱ */
	UDINT       cycleTimeAverage;  /**< ѭƽʱ */
	UINT64      cycleTimeSum;
	
	UDINT       gapTime;	       /**< ѭʱ = current cycleBegin - perious cycleBegin */
	UDINT       gapTimeMin;        /**< ѭ̼ʱ */
	UDINT       gapTimeMax;        /**< ѭʱ */
	UDINT       gapTimeAverage;    /**< ѭƽʱ */
	UINT64      gapTimeSum;
	/* ʱ */
	UDINT       diRefreshTime;    /**< DIˢºʱ */
	UDINT       dqRefreshTime;    /**< DQˢºʱ */

	TASK_TIME_STAT_S* ttsListHeader;  /**< ʱͳƱͷָ */
	
}RSC_CB_S;

typedef enum Configuration_Status_Enum{
	CFG_UNAVAILABLE = 0,
	CFG_READY = 1,
	CFG_RUNNING = 2,
	CFG_ERROR = 3
}CFG_STA_E;

/*ÿƿ*/
typedef struct{
	RSC_CB_S    rscCB;                         /*ǰԴƿ*/
}CFG_CB_S;

extern CFG_CB_S CfgCB;

/* Export function declaration ----------------------------------------------*/
void plcCfgRun(void);
void plcRscTaskSched(RSC_CB_S* pRscCB);
void plcSendMsgToRsc(BYTE evt, TASK_CB_S* pTaskCB);

#endif

