/**
  * @file  plc_stat.h
  * @brief     plc_stat.cͷļ
  * @author    fengzhou
  */

#ifndef _PLC_STAT_H
#define _PLC_STAT_H

#include "plc_port.h"

/* define -------------------------------------------------------------------*/
/* ͳƹصѡ */
#define MAX_STAT_DATA_REGION_SIZE      300    /**< ͳֽ */

#define STAT_DATA_NORMAL_MODE           0   /**< ͨģʽͳ */
#define STAT_DATA_COMPACT_MODE			1   /**< ģʽͳ */
#define STAT_DATA_SAVE_MODE             STAT_DATA_NORMAL_MODE   /**< ͳݱģʽ */
/**
  * ͳݰlabel + evt (+ time length) + time
  * ͨģʽ£ͳݽṹ̶6ֽڣ
  * Byte 1: 	label  	¼ǩ.
  *                		label = ȼ
  *                		Դlabel = ȼPLC_TASK_LOWEST_PRIORITY + 1
  * Byte 2: 	evt    	¼ͣȡֵΧ[0 ~ 255]ܹԱʾ256¼ÿ¼Զ256¼.
  * Byte 3 ~ 6 	time 	ʾǰ¼ϴ¼ʱλ: ΢(us).
  * ģʽ£ͳݽṹȿɱ䣩:
  * Byte 1: 	label  				¼ǩ.
  *                					label = ȼ
  *                					Դlabel = ȼPLC_TASK_LOWEST_PRIORITY + 1
  * Byte 2: 	evt + time length  	¼ + ʱ򳤶.
  *                					6λΪ¼ͣȡֵΧ[0 ~ 63]ܹԱʾ64¼ÿ¼Զ64¼.
  *                					2λΪʱֽڳȣȡֵΧ[0 ~ 3]ֱʾ: 0(1ֽ)1(2ֽ)2(3ֽ)3(4ֽ).
  * Byte 3 ~   	time   				ʱ1ֽ(time length == 0)4ֽ(time length == 3)
  *                                 ʾǰ¼ϴ¼ʱλ: ΢(us).
  */

#define SINGLE_STAT_DATA_SIZE        6                 /**< ÿͳֽ. 
                                                            1byte(label) + 1byte(evt + time length) + 4bytes(time zone)  */

#define PLC_TASK_STAT_DATA_SIZE	(12 * 4)
#define PLC_RSC_STAT_DATA_SIZE	(8 * 4 + PLC_TASK_STAT_DATA_SIZE * (MAX_TASK_NUM_PER_RSC + 1))
#if ((PLC_RSC_STAT_DATA_SIZE + SINGLE_STAT_DATA_SIZE) > MAX_STAT_DATA_REGION_SIZE)
#error "Stat data region size is too small."
#endif
/* typedef ------------------------------------------------------------------*/
/**
  * @brief ͳ¼ö
  */
typedef enum Stat_Event_Type_Enum{
	SE_TYPE_NONE = 0,
	SE_RSC_RUN,
	SE_RSC_STOP,
	SE_RSC_UPDATE,
	SE_RSC_CYCLE_BEGIN,
	SE_RSC_CYCLE_OVER,
	SE_RSC_DI_REFRESH_BEGIN,
	SE_RSC_DI_REFRESH_OVER,
	SE_RSC_DQ_REFRESH_BEGIN,
	SE_RSC_DQ_REFRESH_OVER,
	SE_TASK_TRIGGED,
	SE_TASK_BEGIN,
	SE_TASK_OVER
}STAT_EVT_TYPE_E;
/* Export variables declaration ---------------------------------------------*/
/* Export function declaration ----------------------------------------------*/
void statInit(void);
void statBegin(void);
void statStop(void);
void statClear(void);
unsigned int statEventAdd(unsigned char label, STAT_EVT_TYPE_E evt);
unsigned int statDataAdd(unsigned char* data, unsigned int len);
void statOutput(void);

#endif

